'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

HLL('module:headland.postgres.Row.js', function () {
	HL.loaded(['headland', 'postgres', 'Row'], CL.fun(regeneratorRuntime.mark(function _callee9(CL, HL, $$module) {
		var Model, _2, hop, ops, fkey, _superInit, Row;

		return regeneratorRuntime.wrap(function _callee9$(_context9) {
			while (1) {
				switch (_context9.prev = _context9.next) {
					case 0:
						_context9.next = 2;
						return HL.load(['headland', 'Model'], false, false);

					case 2:
						Model = _context9.sent;
						_2 = void 0;
						hop = Object.prototype.hasOwnProperty;
						ops = {
							'=': '=',
							'<': '<',
							'>': '>',
							'<=': '<=',
							'>=': '>=',
							'!=': '!=',
							'&&': '&&',
							'@@': '@@'
						};

						fkey = function fkey(ikey) {
							if (ikey instanceof QueryBuilder.Raw) return ikey;
							var key = ikey;
							var match = key.match(/^(.*)_id$/);
							if (match) key = match[1];
							return '"' + key.replace('"', '\\"') + '"';
						};

						_superInit = Model.prototype.init;
						Row = Model.extend({
							name: ['headland', 'postgres', 'Row'],
							mode: 'shared',
							fields: {
								init: {
									method: function method(data, exists) {
										var _this = this;

										var _private = this['private:headland.postgres.Row'];

										if (exists) {
											var fields = this.static.classInfo.fields;
											for (var key in data) {
												var field = fields[key];
												var type = field && field.type && field.type();
												var val = data[key];
												if (field && field.sub && val) {
													data[key] = field.sub().fromJSON((typeof val === 'undefined' ? 'undefined' : _typeof(val)) == 'object' ? val : JSON.parse(val));
												}
											}
										}
										var secret = _superInit.call(_this, data, 'cluster', true);
										_private.data = secret.data;
										_private.state = secret.state;
										if (!exists) _private.insert();
									}
								},
								saveChanges: {
									method: CL.fun(regeneratorRuntime.mark(function _callee() {
										var _private, fields, q, i, changes;

										return regeneratorRuntime.wrap(function _callee$(_context) {
											while (1) {
												switch (_context.prev = _context.next) {
													case 0:
														_private = this['private:headland.postgres.Row'];

														if (!_private.state.saved) {
															_context.next = 3;
															break;
														}

														return _context.abrupt('return');

													case 3:
														_private.state.saved = true;

														fields = this.static.classInfo.fields;
														q = new QueryBuilder('UPDATE ' + fkey(this.static.table) + ' SET');
														i = 0;
														changes = _private.state.changes;

														_private.state.changes = {};
														_2.each(changes, function (val, key) {
															var field = fields[key];
															if (!field.type) return;
															if (i++) q.push(',');
															var proper = void 0;
															if ((typeof val === 'undefined' ? 'undefined' : _typeof(val)) == 'object') {
																var type = field.type();
																if (type.indexOf('json') == 0) proper = JSON.stringify(val);else if (type == 'point') proper = '(' + (val.x || val.lon || val.lng || val[0]) + ',' + (val.y || val.lat || val[1]) + ')';else proper = JSON.parse(JSON.stringify(val));
															} else {
																proper = val;
															}
															q.push([fkey(key), '=', [proper]]);
														});

														q.push(['WHERE', fkey('id'), '=', [_private.data.id]]);

														if (!i) {
															_context.next = 14;
															break;
														}

														_context.next = 14;
														return Connection.query(q.get());

													case 14:

														if (_private.state.trigger.length) {
															this.trigger('change', { changes: _2.pick(changes, _private.state.trigger), index: this.getIndexData() });
															_private.state.trigger = [];
														}

													case 15:
													case 'end':
														return _context.stop();
												}
											}
										}, _callee, this);
									}))
								}
							},
							privateFields: {
								data: {},
								state: {},
								insert: {
									method: CL.fun(regeneratorRuntime.mark(function _callee3() {
										var _private;

										return regeneratorRuntime.wrap(function _callee3$(_context3) {
											while (1) {
												switch (_context3.prev = _context3.next) {
													case 0:
														_private = this;
														return _context3.abrupt('return', CL.fun(regeneratorRuntime.mark(function _callee2() {
															var q, keys, values, fields, res, hadId;
															return regeneratorRuntime.wrap(function _callee2$(_context2) {
																while (1) {
																	switch (_context2.prev = _context2.next) {
																		case 0:
																			q = new QueryBuilder('INSERT INTO ' + fkey(this.static.table));
																			keys = [];
																			values = [];
																			fields = this.static.classInfo.fields;


																			_2.each(_private.data, function (val, key) {
																				if (val === void 0) return;
																				if (keys.length) {
																					keys.push(',');
																					values.push(',');
																				}
																				keys.push(fkey(key));
																				var field = fields[key];
																				var proper = void 0;
																				if ((typeof val === 'undefined' ? 'undefined' : _typeof(val)) == 'object') {
																					var type = field.type && field.type();
																					if (type && type.indexOf('json') == 0) proper = JSON.stringify(val);else if (type == 'point') proper = '(' + (val.x || val.lon || val.lng || val[0]) + ',' + (val.y || val.lat || val[1]) + ')';else proper = JSON.parse(JSON.stringify(val));
																				} else {
																					proper = val;
																				}
																				values.push([proper]);
																			});
																			q.push('(', keys, ') VALUES (', values, ') RETURNING *');

																			_context2.next = 8;
																			return Connection.query(q.get());

																		case 8:
																			res = _context2.sent;
																			hadId = _private.data.id !== void 0;

																			_2.each(res.rows[0], function (val, key) {
																				if (_private.data[key] === void 0) _private.data[key] = val;
																			});

																			if (!hadId) this.registerObservable('cluster');
																			this.trigger('create', { data: _private.data });

																		case 13:
																		case 'end':
																			return _context2.stop();
																	}
																}
															}, _callee2, this);
														})).apply(this.public));

													case 2:
													case 'end':
														return _context3.stop();
												}
											}
										}, _callee3, this);
									}))
								}
							},
							statics: {
								fetch: {
									method: 'proxy',
									mode: 'proxy'
								},
								select: {
									method: CL.fun(regeneratorRuntime.mark(function _callee4(opts) {
										var _private, q, i, _i, join, _i2, _i3, key, dir, rq, res, _rq, _res, _rq2, _res2;

										return regeneratorRuntime.wrap(function _callee4$(_context4) {
											while (1) {
												switch (_context4.prev = _context4.next) {
													case 0:
														_private = this['private:headland.postgres.Row'];
														q = new QueryBuilder('SELECT');


														if (opts.count || opts.return == 'count') {
															q.push('COUNT(*) AS ' + fkey('count'));
														} else if (opts.return == 'ids') {
															q.push('id');
														} else if (opts.return == 'data' && opts.select) {
															for (i = 0; i < opts.select.length; i++) {
																if (i) q.push(',');
																q.push(opts.select[i]);
															}
														} else {
															q.push('*');
														}

														q.push('FROM', fkey(this.table));

														if (opts.join && opts.join.length) {
															q.push('JOIN');
															for (_i = 0; _i < opts.join.length; _i++) {
																join = opts.join[_i];

																if (_i) q.push(',');
																if (join instanceof QueryBuilder.Raw) {
																	q.push(join);
																} else {
																	CL.throw('HLPostgreSQLSelect', 'Proper join not implemented, use Raw');
																}
															}
														}

														if (opts.filter) {
															opts.filters = opts.filters || [];
															opts.filters.push(opts.filter);
														}
														if (opts.filters && opts.filters.length) {
															(function () {
																var added = 0;
																var push = function push() {
																	q.push(added++ ? 'AND' : 'WHERE');
																	q.push.apply(q, arguments);
																};
																var _iteratorNormalCompletion = true;
																var _didIteratorError = false;
																var _iteratorError = undefined;

																try {
																	for (var _iterator = opts.filters[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
																		var filter = _step.value;

																		if (_2.isArray(filter)) {
																			if (ops[filter[1]]) push([fkey(filter[0]), ops[filter[1]], [filter[2]]]);else if (filter[1] == 'null') push(fkey(filter[0]), 'IS NULL');else if (filter[1] == '!null') push(fkey(filter[0]), 'IS NOT NULL');else if (filter[1] == 'contains') push([[filter[2]], '= ANY(' + fkey(filter[0]) + ')']);else if (filter[1] == 'in') push([fkey(filter[0]), '= ANY(', [filter[2]], ')']);else CL.throw('HLPostgreSQLSelect', 'Unknown filter passed to select()');
																		} else if (filter instanceof QueryBuilder.Raw) {
																			push(filter);
																		} else if ((typeof filter === 'undefined' ? 'undefined' : _typeof(filter)) == 'object') {
																			_2.each(filter, function (val, key) {
																				push([fkey(key), '=', [val]]);
																			});
																		} else {
																			CL.throw('HLPostgreSQLSelect', 'Unknown filter passed to select()');
																		}
																	}
																} catch (err) {
																	_didIteratorError = true;
																	_iteratorError = err;
																} finally {
																	try {
																		if (!_iteratorNormalCompletion && _iterator.return) {
																			_iterator.return();
																		}
																	} finally {
																		if (_didIteratorError) {
																			throw _iteratorError;
																		}
																	}
																}
															})();
														}

														if (opts.group && opts.group.length) {
															q.push('GROUP BY');
															for (_i2 = 0; _i2 < opts.group.length; _i2++) {
																if (_i2) q.push(',');
																q.push(fkey(opts.group[_i2]));
															}
														}

														if (opts.order && opts.order.length) {
															q.push('ORDER BY');
															for (_i3 = 0; _i3 < opts.order.length; _i3++) {
																key = opts.order[_i3][0];
																dir = opts.order[_i3][1];

																if (_i3) q.push(',');
																q.push(fkey(key), dir.toUpperCase());
															}
														}

														if (opts.offset) q.push('OFFSET', [[opts.offset]]);
														if (opts.limit) q.push('LIMIT', [[opts.limit]]);

														if (!(opts.return == 'query')) {
															_context4.next = 13;
															break;
														}

														return _context4.abrupt('return', q);

													case 13:
														if (!(opts.count || opts.return == 'count')) {
															_context4.next = 21;
															break;
														}

														rq = q instanceof QueryBuilder ? q.get() : q;
														_context4.next = 17;
														return Connection.query(rq);

													case 17:
														res = _context4.sent;
														return _context4.abrupt('return', res.rows[0].count);

													case 21:
														if (!(opts.return == 'ids')) {
															_context4.next = 29;
															break;
														}

														_rq = q instanceof QueryBuilder ? q.get() : q;
														_context4.next = 25;
														return Connection.query(_rq);

													case 25:
														_res = _context4.sent;
														return _context4.abrupt('return', _res.rows.map(function (row) {
															return row.id;
														}));

													case 29:
														if (!(opts.return == 'data')) {
															_context4.next = 37;
															break;
														}

														_rq2 = q instanceof QueryBuilder ? q.get() : q;
														_context4.next = 33;
														return Connection.query(_rq2);

													case 33:
														_res2 = _context4.sent;
														return _context4.abrupt('return', _res2.rows);

													case 37:
														_context4.next = 39;
														return this.runQuery(q);

													case 39:
														return _context4.abrupt('return', _context4.sent);

													case 40:
													case 'end':
														return _context4.stop();
												}
											}
										}, _callee4, this);
									}), {
										loose: true
									})
								},
								runQuery: {
									method: CL.fun(regeneratorRuntime.mark(function _callee5(q) {
										var _private, rq, res, items, i, row, item;

										return regeneratorRuntime.wrap(function _callee5$(_context5) {
											while (1) {
												switch (_context5.prev = _context5.next) {
													case 0:
														_private = this['private:headland.postgres.Row'];
														rq = q instanceof QueryBuilder ? q.get() : q;
														_context5.next = 4;
														return Connection.query(rq);

													case 4:
														res = _context5.sent;
														items = [];

														for (i = 0; i < res.rows.length; i++) {
															row = res.rows[i];
															item = this.getObject(row.id);

															if (!item) item = new this(row, true);
															items.push(item);
														}

														_context5.next = 9;
														return CL.wait(items);

													case 9:
														return _context5.abrupt('return', _context5.sent);

													case 10:
													case 'end':
														return _context5.stop();
												}
											}
										}, _callee5, this);
									}), {
										loose: true
									})
								},
								filterFilters: {
									method: function method(filters) {
										var _private = this['private:headland.postgres.Row'];

										var good = [];
										var bad = [];
										var have = {
											'null': true,
											'!null': true,
											'contains': true
										};
										var _iteratorNormalCompletion2 = true;
										var _didIteratorError2 = false;
										var _iteratorError2 = undefined;

										try {
											for (var _iterator2 = filters[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
												var filter = _step2.value;

												var isarr = _2.isArray(filter);
												if (isarr && (ops[filter[1]] || have[filter[1]]) || !isarr && (typeof filter === 'undefined' ? 'undefined' : _typeof(filter)) == 'object') good.push(filter);else bad.push(filter);
											}
										} catch (err) {
											_didIteratorError2 = true;
											_iteratorError2 = err;
										} finally {
											try {
												if (!_iteratorNormalCompletion2 && _iterator2.return) {
													_iterator2.return();
												}
											} finally {
												if (_didIteratorError2) {
													throw _iteratorError2;
												}
											}
										}

										return { good: good, bad: bad };
									}
								},
								delete: {
									method: CL.fun(regeneratorRuntime.mark(function _callee6(filter) {
										var _private, q;

										return regeneratorRuntime.wrap(function _callee6$(_context6) {
											while (1) {
												switch (_context6.prev = _context6.next) {
													case 0:
														_private = this['private:headland.postgres.Row'];

														if (!filter) {
															_context6.next = 8;
															break;
														}

														q = r.table(this.table);

														if (filter != 'everything') q = q.filter(filter);
														_context6.next = 6;
														return q.delete().run(get().connection, CL.cb());

													case 6:
														_context6.next = 9;
														break;

													case 8:
														CL.throw('HLPostgreSQLDelete', 'Filter or a string "everything" is required');

													case 9:
													case 'end':
														return _context6.stop();
												}
											}
										}, _callee6, this);
									}), {
										loose: true
									})
								},
								configure: {
									method: CL.fun(regeneratorRuntime.mark(function _callee7() {
										var _this2 = this;

										var _private, res, q, num;

										return regeneratorRuntime.wrap(function _callee7$(_context7) {
											while (1) {
												switch (_context7.prev = _context7.next) {
													case 0:
														_private = this['private:headland.postgres.Row'];
														_context7.next = 3;
														return Connection.query('SELECT * FROM information_schema.columns WHERE table_name = $1 AND table_schema = \'public\'', [this.table]);

													case 3:
														res = _context7.sent;
														q = void 0;
														num = 0;

														if (!res.rows.length) {
															(function () {
																var fields = [];
																_2.each(_this2.classInfo.fields, function (field, key) {
																	if (key.match(/_id$/)) return;
																	var add = function add(key) {
																		var str = fkey(key) + ' ' + (field.type() || 'varchar');
																		if (field.primary) str += ' PRIMARY KEY';
																		if (field.unique) str += ' UNIQUE';
																		fields.push(str);
																		num++;
																	};
																	if (field.type || field.sub) {
																		add(key);
																		if (field.translate) {
																			var _iteratorNormalCompletion3 = true;
																			var _didIteratorError3 = false;
																			var _iteratorError3 = undefined;

																			try {
																				for (var _iterator3 = Translation.languages[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
																					var lang = _step3.value;

																					add(key + '_' + lang);
																				}
																			} catch (err) {
																				_didIteratorError3 = true;
																				_iteratorError3 = err;
																			} finally {
																				try {
																					if (!_iteratorNormalCompletion3 && _iterator3.return) {
																						_iterator3.return();
																					}
																				} finally {
																					if (_didIteratorError3) {
																						throw _iteratorError3;
																					}
																				}
																			}
																		}
																	}
																});
																q = 'CREATE TABLE ' + fkey(_this2.table) + ' (' + fields.join(', ') + ')';
															})();
														} else {
															(function () {
																var current = {};
																_2.each(res.rows, function (row) {
																	current[row.column_name] = row;
																});
																var actions = [];
																_2.each(_this2.classInfo.fields, function (field, key) {
																	if (key.match(/_id$/)) return;
																	var add = function add(key) {
																		var cur = current[key];
																		if (!cur) {
																			var str = 'ADD ' + fkey(key) + ' ' + (field.type() || 'varchar');
																			if (field.primary) str += ' PRIMARY KEY';
																			if (field.unique) str += ' UNIQUE';
																			actions.push(str);
																			num++;
																		}
																	};
																	if (field.type || field.sub) {
																		add(key);
																		if (field.translate) {
																			var _iteratorNormalCompletion4 = true;
																			var _didIteratorError4 = false;
																			var _iteratorError4 = undefined;

																			try {
																				for (var _iterator4 = Translation.languages[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
																					var lang = _step4.value;

																					add(key + '_' + lang);
																				}
																			} catch (err) {
																				_didIteratorError4 = true;
																				_iteratorError4 = err;
																			} finally {
																				try {
																					if (!_iteratorNormalCompletion4 && _iterator4.return) {
																						_iterator4.return();
																					}
																				} finally {
																					if (_didIteratorError4) {
																						throw _iteratorError4;
																					}
																				}
																			}
																		}
																	}
																});
																q = 'ALTER TABLE ' + fkey(_this2.table) + ' ' + actions.join(', ');
															})();
														}

														if (!num) {
															_context7.next = 11;
															break;
														}

														console.log(q);
														_context7.next = 11;
														return Connection.query(q);

													case 11:
													case 'end':
														return _context7.stop();
												}
											}
										}, _callee7, this);
									}), {
										loose: true
									})
								}
							},
							privateStatics: {}
						});
						$$module.export(Row);
						$$module.loadDeferred(regeneratorRuntime.mark(function _callee8() {
							return regeneratorRuntime.wrap(function _callee8$(_context8) {
								while (1) {
									switch (_context8.prev = _context8.next) {
										case 0:
											_context8.next = 2;
											return HL.require('lodash', false, true);

										case 2:
											_2 = _context8.sent;

										case 3:
										case 'end':
											return _context8.stop();
									}
								}
							}, _callee8, this);
						}));

					case 11:
					case 'end':
						return _context9.stop();
				}
			}
		}, _callee9, this);
	})), {
		immediate: [['headland', 'Model']],
		deferred: ['lodash']
	});
});
//# sourceMappingURL=/@/es5/headland.postgres.Row.js.map
