'use strict';

HLL('module:headland.postgres.QueryBuilder.js', function () {
	HL.loaded(['headland', 'postgres', 'QueryBuilder'], CL.fun(function* (CL, HL, $$module) {
		let _2;

		let QueryBuilder = HL.Class.extend({
			name: ['headland', 'postgres', 'QueryBuilder'],
			mode: 'shared',
			fields: {
				text: {
					initializer: function () {
						return [];
					}
				},
				values: {
					initializer: function () {
						return [];
					}
				},
				nextId: {
					value: 1
				},
				init: {
					method: function (arg) {
						let _private = this['private:headland.postgres.QueryBuilder'];

						this.push(arg);
					}
				},
				push: {
					method: function () {
						let _private = this['private:headland.postgres.QueryBuilder'];

						for (let i = 0; i < arguments.length; i++) {
							let arg = arguments[i];
							let arr = _2.isArray(arg) ? arg : [arg];
							for (let i = 0; i < arr.length; i++) {
								let item = arr[i];
								if (typeof item == 'string') {
									_private.text.push(item);
								} else if (item instanceof QueryBuilder.Raw) {
									if (_2.isArray(item.value)) {
										for (let j = 0; j < item.value.length; j++) {
											let rs = item.value[j];
											if (_2.isArray(rs)) {
												_private.text.push('$' + _private.nextId++);
												_private.values.push(rs[0]);
											} else {
												_private.text.push(rs);
											}
										}
									} else {
										_private.text.push(item.value);
									}
								} else if (item.length == 1) {
									_private.text.push('$' + _private.nextId++);
									_private.values.push(item[0]);
								} else {
									console.log(item);
									CL.throw('HLPostgreSQLQueryBuilder', 'Wrong query parameter');
								}
							}
						}
					}
				},
				get: {
					method: function () {
						let _private = this['private:headland.postgres.QueryBuilder'];

						return {
							text: _private.text.join(' '),
							values: _private.values
						};
					}
				}
			},
			privateFields: {},
			statics: {},
			privateStatics: {}
		});
		QueryBuilder.Raw = HL.Class.extend({
			name: ['headland', 'postgres', 'QueryBuilder', 'Raw'],
			mode: 'shared',
			fields: {
				value: {},
				init: {
					method: function (value) {
						let _private = this['private:headland.postgres.QueryBuilder.Raw'];

						_private.value = value;
					}
				}
			},
			privateFields: {},
			statics: {},
			privateStatics: {}
		});
		$$module.export(QueryBuilder);
		$$module.loadDeferred(function* () {
			_2 = yield HL.require('lodash', false, true);
		});
	}), {
		immediate: [],
		deferred: ['lodash']
	});
});
//# sourceMappingURL=/@/es6/headland.postgres.QueryBuilder.js.map
