'use strict';

module.exports = [function* (CL, HL, $$module) {
	let _2;

	let _pg;

	let _util;

	let Connection = HL.Class.extend({
		name: ['headland', 'postgres', 'Connection'],
		mode: 'server',
		fields: {
			options: {
				initializer: function () {
					return {};
				},
				const: true
			},
			init: {
				method: function (options) {
					let _private = this['private:headland.postgres.Connection'];

					_private.options = options;
					if (_private.options.global) Connection.global = this;
				}
			}
		},
		privateFields: {},
		statics: {
			pg: {
				initializer: function () {
					return _pg;
				},
				const: true
			},
			global: {
				public: true
			},
			query: {
				method: CL.fun(function* (query, params) {
					let _private = this['private:headland.postgres.Connection'];

					let obj = CL.get('postgresql') || Connection.global;
					let c = CL.expect();
					c.tag = _util.inspect(query);
					_pg.connect(obj.options.string, function (err, client, done) {
						if (err) return c.throw(err);
						let cb = function (err, res) {
							if (err) {
								done(true);
								return c.throw(err);
							}
							done();
							c.done(res);
						};
						client.query.apply(client, arguments.length == 1 ? [query, cb] : [query, params, cb]);
					});
					return c;
				}, {
					loose: true
				})
			}
		},
		privateStatics: {}
	});
	$$module.export(Connection);
	$$module.loadDeferred(function* () {
		_2 = require('lodash');
		_pg = require('pg');
		_util = require('util');
	});
}, {
	client: [],
	clientDeferred: ['lodash'],
	server: [],
	serverDeferred: ['lodash', 'pg', 'util']
}];
//# sourceMappingURL=Connection.js.map
